SLASH_CENTER1 = "/center"
SLASH_HELPPRL1 = "/prl"
SLASH_HELPPRL2 = "/PRL"
SLASH_HELPPRL3 = "/pocketraidleader"
SLASH_HELPPRL4 = "/PocketRaidLeader"
SLASH_TOGGLE1 = "/toggle"
SLASH_TOGGLE2 = "/Toggle"
--Commands ^^
local boss = "Goroth"
local raid = "Tomb of Sargeras"
-- Create the dropdown menu and change its appearance
toggle = true
local dropDown = CreateFrame("FRAME", "WPDemoDropDown", UIParent, "UIDropDownMenuTemplate")
dropDown:SetPoint("CENTER")
UIDropDownMenu_SetWidth(dropDown, 250)
UIDropDownMenu_SetText(dropDown, raid .. ": " .. boss)
-- Making the menu movable on drag
dropDown:SetMovable(true)
dropDown:SetResizable(true)
dropDown:EnableMouse(true)
dropDown:RegisterForDrag("LeftButton")
dropDown:SetScript("OnDragStart", dropDown.StartMoving)
dropDown:SetScript("OnDragStop", dropDown.StopMovingOrSizing)

-- The main drop down menu
UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
 local info = UIDropDownMenu_CreateInfo()
 -- Arrays for menu options
 local raids = {"Emerald Nightmare", "Trial Of Valor", "Nighthold", "Tomb Of Sargeras", "Antorus, the Burning Throne"}
 --local emerald_nightmare={"Nythendra", "Il'gynoth, Heart of Curruption", "Elerethe Renferal", "Ursoc", "Dragons of Nightmare", "Cenarius", "Xavius"}
 --local trial_of_valor={"Odyn", "Guarm", "Helya"}
 --local nighthold={"Skorpyron", "Chronomatic Anomaly", "Trilliax", "Spellblade Aluriel", "Tichondrius", "Krosus", "High Botanist Tel'arn", "Star Augur Etraeus", "Grand Magistrix Elisande", "Gul'dan"}
 --local tomb_of_sargeras={"Goroth", "Demonic Inquisition", "Harjatan", "Sisters of the Moon", "Mistress Sassz'ine", "The Desolate Host", "Maiden of Vigilance", "Fallen Avatar", "Kil'jaeden"}
 local antorus_the_burning_throne={"Garothi Worldbreaker", "Felhounds of Sargeras", "Antoran High Command", "Portal Keeper Hasabel", "Eonar the Life-Binder", "Imonar the Soulhunter", "Kin'garoth", "Varimathras", "The Coven of Shivarra", "Aggramar", "Argus the Unmaker"}
 
 if (level or 1) == 1 then
  -- Display all legion raids
  for i=5,5 do
   info.text, info.checked = raids[i]
   info.menuList, info.hasArrow = i, true
   UIDropDownMenu_AddButton(info, level)
  end

 else
  -- Display bosses for which ever raid you hover over
  info.func = self.SetValue
  --if menuList ==1 then
   --for i=1,7 do
    --info.text, info.arg1, info.checked = emerald_nightmare[i], emerald_nightmare[i], emerald_nightmare[i]
    --UIDropDownMenu_AddButton(info, level)
	--raid="Emerald Nightmare"
   --end
  --end
  --if menuList==2 then
   --for i=1,3 do
    --info.text, info.arg1, info.checked = trial_of_valor[i], trial_of_valor[i], trial_of_valor[i]
    --UIDropDownMenu_AddButton(info, level)
	--raid="Trial of Valor"
   --end
  --end
  --if menuList==3 then
   --for i=1,10 do
    --info.text, info.arg1, info.checked = nighthold[i], nighthold[i], nighthold[i]
    --UIDropDownMenu_AddButton(info, level)
	--raid="The Nighthold"
  --end
  --end
  --if menuList==4 then
   --for i=1,9 do
    --info.text, info.arg1, info.checked = tomb_of_sargeras[i], tomb_of_sargeras[i], tomb_of_sargeras[i]
    --UIDropDownMenu_AddButton(info, level)
	--raid="Tomb of Sargeras"
   --end
  --end
  if menuList==5 then
   raid="Antorus, the Burning Throne"
   for i=1,11 do
    info.text, info.arg1, info.checked = antorus_the_burning_throne[i], antorus_the_burning_throne[i], antorus_the_burning_throne[i]
    UIDropDownMenu_AddButton(info, level)
   end
  end
 end
end)
-- Function that prints strat to screen on click
function dropDown:SetValue(newValue)
 if newValue == "Mistress Sassz'ine" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Mistress Sassz'ine(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1 (100%-70% HP)")
  print("|cff00ff00 Kill Adds when [Slicing Tornado] spawns (Slicing Tornado is a row of tornados which disapear when adds killed")
  print("|cff00ff00 If you got murlock on you stand in jellyfish circle")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2 (70%-40% HP)")
  print("|cffFF4500 Dodge the waves")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3 (40%-0% HP)")
  print("-------------------------------------------------------------------")
 elseif newValue == "Garothi Worldbreaker" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Garothi Worldbreaker(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("|cffffcc00 Note: Throughout this fight the raid should stay loosly stacked")
  print("|cffffcc00 Note For TANKS ONLY: When your fellow tank gets |cffffff00 [Fel Bombardment] |cffffcc00 debuff they should run to back of room and you should taunt")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1 (100%-65% HP)")
  print("|cff00ff00 Soak |cffffff00 [Annihilation] |cff00ff00 by having at least 1 person standing in each puddle")
  print("|cff00ff00 If you have |cffffff00 [Decimation] |cff00ff00 debuff run away from the rest of the raid")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2 (65%-25% HP)")
  print("|cffFF4500 Kill at least 1 of the weapons before |cffffff00 [Apocalypse Drive] |cffFF4500 cast (30 seconds) has been finished (recommended to destroy 'Annhilator' weapon)")
  print("|cffFF4500 After |cffffff00 [Apocalypse Drive] [Eradication]|cffFF4500 will be cast (5.5 seconds) the further away you are from the boss the less damage, keep 1 tank with big damage reduction next to boss to stop [Carnage] from being channeled")
  print("|cffff4500 After this the raid takes 20% more damage due to |cffffff00 [Empowered] |cffff4500 and receive |cffffff00 [Searing Barrage] |cffff4500 ticking damage (2 seconds)")
  print("|cffff4500 Players with |cffffff00 [Decimation] |cffff4500 run away from group")
  print("|cffFF4500 Dont stand in |cffffff00 [Surging Fel] |cffFF4500 (only on heroic difficulty)")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3 (25%-0% HP)")
  print("|cffff0000 At 20% |cffffff00 [Apocalypse Drive] |cffff0000 will be cast again (recommended to destroy 'Annhilator' weapon)")
  print("|cffff0000 Now |cffffff00 [Eradication] |cffff0000 will be cast again but does 20% more damage due |cffffff00 [Empowered]")
  print("|cffff0000 The boss will now gain another stack of |cffffff00 [Empowered] |cffff0000 and |cffffff00 [Searing Barrage]|cffff0000 (unavoidable)")
  print("-------------------------------------------------------------------")
 elseif newValue == "Felhounds of Sargeras" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Felhounds of Sargeras(Normal/Heroic) Tactics: ")
  print("|cffff0000 There are no phases to this boss but the hounds will cast different abilities at certain energy levels")
  print("|cffffcc00 Note: Keep hounds seperated")
  print("|cffffcc00 Note: Melee attack 'Shatug'")
  print("|cffffcc00 Note: No need to tank swap")
  print("|cffffcc00 Note: Health bar shared between bosses")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 33% Energy")
  print("|cff00ff00 Shatug- Run away from |cffffff00 [Consuming Sphere] |cff00ff00 as it will deal ticking damage and pull you in ")
  print("|cff00ff00 F'harg- When |cffffff00 [Desolate Gaze] |cff00ff00 is cast the group should spread")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 66% Energy (Heroic Only)")
  print("|cffFF4500 Shatug- People affected with |cffffff00 [Weight of Darkness] |cffFF4500 should stack with at least 2 other players")
  print("|cffFF4500 F'harg- During |cffffff00 [Molten Touch] |cffFF4500 the group should spread and dodge the fire")
  print("-------------------------------------------------------------------")
  print("|cffff0000 100% Energy")
  print("|cffff0000 Shatug- Everyone should stack during |cffffff00 [Siphon Corruption]")
  print("|cffff0000 F'harg- Spread the group for |cffffff00 [Enflame Corruption]")
  print("-------------------------------------------------------------------")
 elseif newValue == "Antoran High Command" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Antoran High Command(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("|cffffcc00 Note: 3 bosses in clockwise spawn locations")
  print("|cffffcc00 Note: Throughout the encounter there will be mines on the floor, dont stand on them")
  print("|cffffcc00 Note: There is a pod with different abilities behind each current boss, always have someone inside keep using the first damage attack and save the pods where you have shield for 'Fusillade'")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1- Admiral Svirax")
  print("|cff00ff00 Group should be loosely spread")
  print("|cff00ff00 Adds will spawn during this boss, run away from spinning adds")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- Chief Engineer Ishkar")
  print("|cffFF4500 Person in engineer pod should place felsheild on raid when |cffffff00 [Fusillade] |cffFF4500 is cast")
  print("|cffFF4500 Same adds will spawn")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3- General Erodus")
  print("|cffff0000 Person in engineer pod should place felsheild on raid when |cffffff00 [Fusillade] |cffff0000 is cast")
  print("|cffff0000 Keep boss in area clear from mines ready for more mines")
  print("-------------------------------------------------------------------")
 elseif newValue == "Portal Keeper Hasabel" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Portal Keeper Hasabel(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("|cffffcc00 Note: 1 tank, most healers and aoe DPS should stay on main boss platform all the time")
  print("|cffffcc00 Note: Tank main boss at side of room for [Collapsing World]")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1- Orange Platform (90% Boss HP)")
  print("|cff00ff00 1 tank, 1 healer and most single target DPS go to platform")
  print("|cff00ff00 Interrupt attacks")
  print("|cff00ff00 Dont stand in fire")
  print("|cff00ff00 When fire boss is dead have 1 or 2 players take an orb to the void platform for visibility")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- Green Platform (60% Boss HP)")
  print("|cffFF4500 Same players go to platform as before but take 1 more healer")
  print("|cffFF4500 Interrupt casts")
  print("|cffFF4500 Stack under boss")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3- Purple Platform (30% Boss HP)")
  print("|cffff0000 Same group go up again")
  print("|cffff0000 Stay near boss or orange orbs so you can target")
  print("|cffff0000 Interrupt casts")
  print("|cffff0000 Healers dispel |cffffff00 [Delusions] |cffff0000 but wait a bit to save mana")
  print("|cffff0000 If you run into orb dont dispel or use immunity because it will disappear")
  print("-------------------------------------------------------------------")
 elseif newValue == "Eonar the Life-Binder" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Eonar the Life-Binder(Normal/Heroic) Tactics: ")
  print("|cffffcc00 Note: You dont actually fight a boss in this, its waves of adds instead")
  print("|cffffcc00 Note: You gain an ability that lets you jump really high and glide")
  print("|cffffcc00 Note: There are jump pads between lanes for speed")
  print("|cffffcc00 Note: The fight will end when the Paraxis reaches 0 health, this is done by defeating waves of adds without allowing them to get to Eonar")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Waves of adds will spawn at doors around the map")
  print("|cff00ff00 Make sure to engage large adds before they start shooting Eonar")
  print("-------------------------------------------------------------------")
 elseif newValue == "Imonar the Soulhunter" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Imonar the Soulhunter(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1- 100-66% HP")
  print("|cff00ff00 Move away from players affected with |cffffff00 [Sleep Canister]")
  print("|cff00ff00 Tank boss around edge of area")
  print("|cff00ff00 Stay away from stuff")
  print("|cff00ff00 If affected with a grenade run away from group")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- 66-33% HP")
  print("|cffFF4500 Obstacle course run at 66%")
  print("|cffFF4500 Group should move as one around edge of room for |cffffff00 [Shrapnel Blast]")
  print("|cffFF4500 Players affected by |cffffff00 [Charged Blast] |cffFF4500 should move away from players")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3- 33-0% HP")
  print("|cffff0000 Obstacle course run at 33%")
  print("|cffff0000 Use bloodlust")
  print("|cffff0000 Players afftected with grenade should move away from group")
  print("-------------------------------------------------------------------")
 elseif newValue == "Kin'garoth" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Kin'garoth(Normal/Heroic) Tactics: ")
  print("|cffff0000 2 repeated phases to this boss")
  print("|cffffcc00 Note: DONT STAND NEXT TO TANK!")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1")
  print("|cff00ff00 Boss will shoot a beam of fel energy and start to turn it around the map, dodge it")
  print("|cff00ff00 Marks will appear on the floor, these pulse damage to people close to them")
  print("|cff00ff00 Big purple orbs will begin to roll around map which only stop when they hit a player")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- 100% Energy")
  print("|cffFF4500 3 Fel Reavers will spawn, either all move to same one and nuke or split raid in half (Fel Reavers take 90% more damage when they first spawn so burst as soon as possible)")
  print("|cffFF4500 Each colour of Fel Reaver have unique abilities, soak green circles, run away with |cffffff00 [Decimation] |cffFF4500 (comes from red Fel Reaver) and stack for |cffffff00 [Demolish] |cffFF4500 (comes from purple Fel Reaver") 
  print("|cffFF4500 You will now return to phase 1")
  print("-------------------------------------------------------------------")
 elseif newValue == "Varimathras" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Varimathras(Normal/Heroic) Tactics: ")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Have 2 markers placed at the back-left and back-right side of the boss")
  print("|cff00ff00 Always stay behind the boss if you are not a tank")
  print("|cff00ff00 Always have entire raid stacked as a debuff is applied to anyone 8 yards away from another")
  print("|cff00ff00 When |cffffff00 [Dark Fissures] |cff00ff00 open up move as group to next mark")
  print("|cff00ff00 Have a mobile melee DPS intercept [Marked Prey]")
  print("|cff00ff00 If you have [Necrotic Embrace] run 10 yards away from group (Heroic only)")
  print("-------------------------------------------------------------------")
 elseif newValue == "The Coven of Shivarra" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 The Coven of Shivarra(Normal/Heroic) Tactics: ")
  print("|cffffcc00 Note: Bosses share health")
  print("|cffffcc00 Note: Keep bosses 18 yards apart")
  print("|cffffcc00 Note: Kill ghosts of Aman'Thul adds (these can not be tanked)")
  print("|cffffcc00 Note: Spread raid for [Torment of Golganneth] and kill adds")
  print("|cffffcc00 Note: Run to edges of room for [Torment of Khaz'goroth] and kill adds")
  print("|cffffcc00 Note: Dodge all [Torment of Norgannon] adds, which can be killed after 30 seconds")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Noura")
  print("|cff00ff00 Avoid tornado")
  print("|cff00ff00 Keep boss faced away from raid")
  print("|cff00ff00 Players with |cffffff00 [Fulminating Pulse] |cff00ff00 should run away from group")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Asara")
  print("|cffFF4500 Dodge purple blades which fire across map")
  print("|cffFF4500 During |cffffff00 [Storm of Darkness] |cffFF4500 run to safe zone (white area)")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Diima")
  print("|cffff0000 Tank swap before stacks of |cffffff00 [Flashfreeze] |cffff0000 get too high")
  print("|cffff0000 Try and stay as far away from |cffffff00 [Orb of Frost] |cffff0000 as possible (big white swirl)")
  print("-------------------------------------------------------------------")
 elseif newValue == "Aggramar" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Aggramar(Normal/Heroic) Tactics: ")
  print("|cffff0000 3 Phases to this boss")
  print("|cffffcc00 Note: Tanks always stay together")
  print("|cffffcc00 Note: At 100 energy 5 attacks will be cast in the same order as following: |cffffff00 [Foe Breaker] |cffffcc00 stack behind boss apart from 1 tank, |cffffff00 [Flame Rend] |cffffcc00 Stack in front of boss, |cffffff00 [Foe Breaker] |cffffcc00 another tank should take this hit, |cffffff00 [Flame Rend] |cffffcc00 same as last time, |cffffff00 [Searing Temptes] |cffffcc00 run away from the boss")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1- 100-80% HP")
  print("|cff00ff00 Start with group being spread to avoid pulse damage and help dodging flames")
  print("|cff00ff00 At 80% HP the boss will become immune to damage, 2 big adds will now spawn which need to be tanked on opposite sides of the boss while dps should focus on killing smaller adds before they reach the boss (these can be crowd controlled)")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- 80-40% HP")
  print("|cffFF4500 The flame wave ability will now be replaced with |cffffff00 [Flare] |cffFF4500 which deals area damage to 3 random places, just dodge these")
  print("|cffFF4500 At 40% health the same will happen as at 80%")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 3- 40-0%")
  print("|cffff0000 Waves of flames will now return when |cffffff00 [Flare] |cffff0000 expires")
  print("-------------------------------------------------------------------")
 elseif newValue == "Argus the Unmaker" then
  print("-------------------------------------------------------------------")
  print("|cffff0000 Argus the Unmaker(Normal/Heroic) Tactics: ")
  print("|cffff0000 4 Phases to this boss")
  print("-------------------------------------------------------------------")
  print("|cff00ff00 Phase 1- 100-70% HP")
  print("|cff00ff00 Stack behind boss")
  print("|cff00ff00 Every time the boss reaches 100 Titanic Essence he will cast |cffffff00 [Cone of Death] |cff00ff00 the raid should move clockwise each time this is cast")
  print("|cff00ff00 Players with |cffffff00 [Soulblight] |cff00ff00 should move behind group")
  print("|cffffff00 [Golganneth's Aid] |cff00ff00 will give 2 players |cffffff00 [Gift of the Sky] |cff00ff00 or |cffffff00 [Gift of the Sea] |cff00ff00 these orbs should be placed in accessible locations and will buff players with certain stats when they walk into them, |cffffff00 [Gift of the Sky] |cff00ff00 will give more Critical Strike and Mastery while |cffffff00 [Gift of the Sea] |cff00ff00 will give Versatility and Haste (only one set of buffs can be obtained at a time)")
  print("-------------------------------------------------------------------")
  print("|cffFF4500 Phase 2- 70-40% HP")
  print("|cffFF4500 At the start of this phase all the fog will clear")
  print("|cffFF4500 Dodge the scythes which will travel forwards in the marked area")
  print("|cffFF4500 At 100 energy 2 players will receive |cffffff00 [Soulburst] |cffFF4500 and 1 player will receive |cffffff00 [Soulbomb] |cffFF4500 make sure each of the 3 players get to different corners of the map to each other, the player with |cffffff00 [Soulbomb] |cffFF4500 should be accompanied by a tank with |cffffff00 [Aggramar's Boom] |cffFF4500 buff")
  print("|cffFF4500 At 50 energy the same will happen but only for 2 |cffffff00 [Soulburst]")
  print("-------------------------------------------------------------------")
  print("|cffff6060 Phase 3- 40%")
  print("|cffff6060 At 40% the boss will split into 7 adds")
  print("|cffff6060 Spread in the middle of the map to dodge |cffffff00 [Cosmic Ray]")
  print("|cffff6060 Only interrupt |cffffff00 [Cosmic Beacon] |cffff6060 casts from adds")
  print("|cffff6060 2 of the adds will gain weapons randomly, each tank should taunt 1 with the add holding the blue weapon being tanked near another casting add while the other add with the weapon should be moved 20 yards away from any other adds")
  print("|cffff6060 Each add will receive extra damage from certain types of magic, so make sure you are attacking the one which your class is strong against")
  print("-------------------------------------------------------------------")
  print("|cffff0000 Phase 4- 40-0% HP")
  print("|cffff0000 Once all adds are killed stack in the middle of the map")
  print("|cffff0000 You will now all die, but a tree will spawn")
  print("|cffff0000 Now everyone can release spirit and should walk to the tree to ressurect while dodging the small adds, which knock you back")
  print("|cffff0000 Each time the tree is used it will loose energy and health, although healers can heal the tree")
  print("|cffff0000 Interrupt the cast |cffffff00 [End of All Things] |cffff0000 when you have a tank ready otherwise bad things happen")
  print("|cffff0000 Stack behind the boss and dodge |cffffff00 [Ember of Rage]")
  print("|cffff0000 Kill Reorigination Modules quickly, on death these will drop motes for dead people to pick up in the spirit world which give Khaz'goroth power which in turn buffs the raid whenever it is above 20")
  print("|cffff0000 On heroic difficulty tanks should tank the boss until they die during this phase")
  print("-------------------------------------------------------------------")
 end

 boss = newValue
 UIDropDownMenu_SetText(dropDown, raid .. ": " .. boss)
 -- Close the entire menu
 CloseDropDownMenus()
end

-- Functions for commands
SlashCmdList["TOGGLE"] = function(UIDropDownMenu)
   if toggle==true then
    dropDown:Hide()
	toggle=false
   else
    dropDown:Show()
	toggle=true
   end
end
SlashCmdList["CENTER"] = function(UIDropDownMenu)
   dropDown:ClearAllPoints()
   dropDown:SetPoint("CENTER")
   print("|cffffff00 Resetting position to center of screen...")
end
SlashCmdList["HELPPRL"] = function(UIDropDownMenu)
   print("|cffffff00 -------------------------------------------------------------------")
   print("|cffffff00 Help for Pocket Raid Leader")
   print("|cffffff00 This addon gives you a drop down menu to use to retrieve boss strats")
   print("|cffffff00 Type /center to reset frame position")
   print("|cffffff00 Type /toggle to toggle the menu on/off")
   print("|cffffff00 -------------------------------------------------------------------")
end